> This is a page from the ElevenLabs documentation. For a complete page index, fetch https://elevenlabs.io/docs/llms.txt. For the full documentation in a single file, fetch https://elevenlabs.io/docs/llms-full.txt.

# List MCP server tools

GET https://api.elevenlabs.io/v1/convai/mcp-servers/{mcp_server_id}/tools

Retrieve all tools available for a specific MCP server configuration.

Reference: https://elevenlabs.io/docs/api-reference/mcp/list-tools

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: api
  version: 1.0.0
paths:
  /v1/convai/mcp-servers/{mcp_server_id}/tools:
    get:
      operationId: list
      summary: List Mcp Server Tools
      description: Retrieve all tools available for a specific MCP server configuration.
      tags:
        - >-
          subpackage_conversationalAi.subpackage_conversationalAi/mcpServers.subpackage_conversationalAi/mcpServers/tools
      parameters:
        - name: mcp_server_id
          in: path
          description: ID of the MCP Server.
          required: true
          schema:
            type: string
        - name: xi-api-key
          in: header
          required: false
          schema:
            type: string
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ListMCPToolsResponseModel'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
servers:
  - url: https://api.elevenlabs.io
  - url: https://api.us.elevenlabs.io
  - url: https://api.eu.residency.elevenlabs.io
  - url: https://api.in.residency.elevenlabs.io
components:
  schemas:
    Icon:
      type: object
      properties:
        src:
          type: string
        mimeType:
          type:
            - string
            - 'null'
        sizes:
          type:
            - array
            - 'null'
          items:
            type: string
      required:
        - src
      description: An icon for display in user interfaces.
      title: Icon
    ToolAnnotations:
      type: object
      properties:
        title:
          type:
            - string
            - 'null'
        readOnlyHint:
          type:
            - boolean
            - 'null'
        destructiveHint:
          type:
            - boolean
            - 'null'
        idempotentHint:
          type:
            - boolean
            - 'null'
        openWorldHint:
          type:
            - boolean
            - 'null'
      description: |-
        Additional properties describing a Tool to clients.

        NOTE: all properties in ToolAnnotations are **hints**.
        They are not guaranteed to provide a faithful description of
        tool behavior (including descriptive properties like `title`).

        Clients should never make tool use decisions based on ToolAnnotations
        received from untrusted servers.
      title: ToolAnnotations
    ToolExecutionTaskSupport:
      type: string
      enum:
        - forbidden
        - optional
        - required
      title: ToolExecutionTaskSupport
    ToolExecution:
      type: object
      properties:
        taskSupport:
          oneOf:
            - $ref: '#/components/schemas/ToolExecutionTaskSupport'
            - type: 'null'
      description: Execution-related properties for a tool.
      title: ToolExecution
    Tool:
      type: object
      properties:
        name:
          type: string
        title:
          type:
            - string
            - 'null'
        description:
          type:
            - string
            - 'null'
        inputSchema:
          type: object
          additionalProperties:
            description: Any type
        outputSchema:
          type:
            - object
            - 'null'
          additionalProperties:
            description: Any type
        icons:
          type:
            - array
            - 'null'
          items:
            $ref: '#/components/schemas/Icon'
        annotations:
          oneOf:
            - $ref: '#/components/schemas/ToolAnnotations'
            - type: 'null'
        _meta:
          type:
            - object
            - 'null'
          additionalProperties:
            description: Any type
        execution:
          oneOf:
            - $ref: '#/components/schemas/ToolExecution'
            - type: 'null'
      required:
        - name
        - inputSchema
      description: Definition for a tool the client can call.
      title: Tool
    ListMCPToolsResponseModel:
      type: object
      properties:
        success:
          type: boolean
          description: Indicates if the operation was successful.
        tools:
          type: array
          items:
            $ref: '#/components/schemas/Tool'
          description: A list of tools available on the MCP server.
        error_message:
          type:
            - string
            - 'null'
          description: Error message if the operation was not successful.
      required:
        - success
        - tools
      description: Response model for testing tools available on an MCP server.
      title: ListMCPToolsResponseModel
    ValidationErrorLocItems:
      oneOf:
        - type: string
        - type: integer
      title: ValidationErrorLocItems
    ValidationError:
      type: object
      properties:
        loc:
          type: array
          items:
            $ref: '#/components/schemas/ValidationErrorLocItems'
        msg:
          type: string
        type:
          type: string
      required:
        - loc
        - msg
        - type
      title: ValidationError
    HTTPValidationError:
      type: object
      properties:
        detail:
          type: array
          items:
            $ref: '#/components/schemas/ValidationError'
      title: HTTPValidationError

```

## SDK Code Examples

```typescript
import { ElevenLabsClient } from "@elevenlabs/elevenlabs-js";

async function main() {
    const client = new ElevenLabsClient();
    await client.conversationalAi.mcpServers.tools.list("mcp_server_id");
}
main();

```

```python
from elevenlabs import ElevenLabs

client = ElevenLabs()

client.conversational_ai.mcp_servers.tools.list(
    mcp_server_id="mcp_server_id",
)

```

```go
package main

import (
	"fmt"
	"net/http"
	"io"
)

func main() {

	url := "https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools"

	req, _ := http.NewRequest("GET", url, nil)

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.get("https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('GET', 'https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools');

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools");
var request = new RestRequest(Method.GET);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let request = NSMutableURLRequest(url: NSURL(string: "https://api.elevenlabs.io/v1/convai/mcp-servers/mcp_server_id/tools")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "GET"

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```